/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 *
 */
package com.mysema.commons.fluxml;

import java.io.IOException;
import java.io.Writer;

/**
 * XMLWriter provides a fluent API for XML/XHTML serialization
 * 
 * @author tiwe
 * @version $Id$
 */
public class XMLWriter extends AbstractMarkupWriter<XMLWriter> {
    public XMLWriter(Writer writer) {
        super(writer);
    }

    @Override
    protected void escapeMarkup(Writer writer, String val) throws IOException {
        for (int i = 0; i < val.length(); ++i) {
            char c = val.charAt(i);
            if (c == '&') {
                writer.write("&amp;");
            } else if (c == '<') {
                writer.write("&lt;");
            } else if (c == '>') {
                writer.write("&gt;");
            } else if (c == '"') {
                writer.write("&quot;");
            } else if (c == '\'') {
                writer.write("&apos;");
            } else {
                writer.write(c);
            }
        }
    }

    @Override
    protected void closeEmptyTag(Writer writer) throws IOException {
        writer.write("/>");
    }

}
